<?php

/**
 * Class d3birthdayvoucher_update
 */
class d3birthdayvoucher_update extends d3install_updatebase
{

    protected $_aRefreshMetaModuleIds = array();
    public $aMultiLangTables = array();

    public $aRenameTables = array(
    array(),
    );

    public $sModRevision = '210';
    public $sModKey = 'd3birthdayvoucher';
    public $sModName = 'Geburtstagsgutscheine';
    public $sModVersion = '3.1.0.3';
    public $sModBaseConfKey = '9U3Nk13U1FmZEVDazJ4dHFsQW96TXppb1dVUWs4YjMzNkoxNVlWSVJMNGJkekhPVktWYjI1RVUwRUJpb
0hkVDFEWHdwQjFOd3k0MHBoWGw1ZDl2MmtTRmZQYmVzelVQeFovdmQ1Vk41d0kweUh5Y2RhM2NNaWl4U
HVLQWcxbmQ1aXZBWURZcmVIdjIvTUtZT2phdVZnNFFXMzZTOEsvdUgrL2RKZlN4TjhYN0ZvWDlHZjBFW
jdrdVRnendwdkhaeUxQMm5FM1h0WkE3dlhNN0w1ek84QVM2ZDg4NWVBNTN2cDhZQnFpNmVMUmptalUrY
ksyNVNqaDBwQ2RzQmdjdno5OEVEM2JWRjZjS0JDUUpjT0xYMk95VXcrYitqY1lFdXZWMzV4ZG91d1ptK
zQ9';

    public $sRequirements ='';


    // auszufhrende Check- und Updateanweisungen in auszufhrender Reihenfolge
    protected $_aUpdateMethods = array(
        array('check' => 'checkMultiLangTables',
            'do' => 'fixRegisterMultiLangTables'),
        #array('check' => 'checkRenameTables', // prft auf umzubenennende Tabellen und fhrt dies ggf. aus
        #    'do' => 'fixRenameTables'),
        #array('check' => 'checkTestTableExist', // prft Tabelle und legt sie ggf. an
        #    'do' => 'updateTestTableExist'),
        array('check' => 'checkRenameFields', // prft auf umzubenennende Felder und fhrt dies ggf. aus
            'do' => 'fixRenameFields'),
        array('check' => 'checkFields', // prft Felder in Tabelle und legt sie ggf. an bzw. modifiziert diese
            'do' => 'fixFields'),
        array('check' => 'checkIndizes', // prft Indizes in Tabelle und legt sie ggf. an
            'do' => 'fixIndizes'),
        array('check' => 'checkModCfgItemExist', // prft auf DB-Eintrag (hier ModCfg) und fgt diese ggf. ein bzw. fhrt Update aus
            'do' => 'updateModCfgItemExist'),
        array('check' => 'checkVoucherSeriesItemExist', // prft auf DB-Eintrag (hier ModCfg) und fgt diese ggf. ein bzw. fhrt Update aus
            'do' => 'updateVoucherSeriesItemExist'),

        /*
        array('check' => 'checkCmsItems',
            'do' => 'updateCmsItems'),
        */
/*
        array('check' => 'checkCmsItems_01',
            'do' => 'executeCmsTypesItemsList_01'),
        array('check' => 'checkCmsItems_02',
            'do' => 'executeCmsTypesItemsList_02'),
        array('check' => 'checkCmsItems_03',
            'do' => 'executeCmsTypesItemsList_03'),
*/
        array('check' => 'checkModCfgSameRevision', // prft auf nachgezogene Revisionsnummer und bertrgt diese ggf.
            'do' => 'updateModCfgSameRevision'),
    );


    // Standardwerte fr checkFields(), _addTable() und fixFields()
    public $aFields = array(
        array(
            'sTableName' => 'oxuser',
            'sFieldName' => 'D3BIRTHDAYVOUCHER_LASTDATE',
            'sType' => 'date',
            'blNull' => TRUE,
            'sDefault' => '0000-00-00',
            'sComment' => 'send last BirthdayVoucher on',
            'sExtra' => '',
            'blMultilang' => FALSE,
        ),
    );

    // Standardwerte fr checkIndizes() und fixIndizes()
    public $aIndizes = array();

    // Standardwerte fr checkRenameFields() und fixRenameFields()
    public $aRenameFields = array(
        array(
            'sTableName' => 'oxuser',
            'mOldFieldNames' => array('d3lastbdvoucherdate','D3LASTBDVOUCHERDATE'), // is case sensitive
            'sFieldName' => 'D3BIRTHDAYVOUCHER_LASTDATE',
            'sComment' => 'send last BirthdayVoucher on',
            'blMultilang' => FALSE,
            'blNull' => TRUE,
            'sDefault' => '0000-00-00',
            'use_quote' => false,
        ),
    );

    /*******************************************************************************************/
    /***** eigene Test- und Updatemethoden (ggf. berladung vorhandener Methoden) **************/
    /*******************************************************************************************/

    /**
     * @return bool
     */
    public function checkModCfgItemExist()
    {
        $blRet = false;
        foreach ($this->_getShopList() as $oShop) {
            /** @var $oShop oxshop */
            $aWhere = array(
            'oxmodid'       => $this->sModKey,
            'oxnewrevision' => $this->sModRevision,
            'oxshopid'      => $oShop->getId(),
            );

            $blRet = $this->_checkTableItemNotExist('d3_cfg_mod', $aWhere);

            if ($blRet) {
                return $blRet;
            }
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateModCfgItemExist()
    {
        $blRet = FALSE;

        if ($this->checkModCfgItemExist()) {
            foreach ($this->_getShopList() as $oShop) {
                /** @var $oShop oxshop */
                $aWhere = array(
                    'oxmodid' => $this->sModKey,
                    'oxshopid' => $oShop->getId(),
                    'oxnewrevision' => $this->sModRevision,
                );
                if($this->_checkTableItemNotExist('d3_cfg_mod',$aWhere))
                {
                    // update don't use this property
                    unset($aWhere['oxnewrevision']);
                    $aInsertFields = array(
                        array(
                            'fieldname' => 'OXID',
                            'content' => "md5('" . $this->sModKey . " " . $oShop->getId() . " de')",
                            'force_update' => FALSE,
                            'use_quote' => FALSE,
                            'use_multilang' => FALSE,
                        ),
                        array(
                            'fieldname' => 'OXSHOPID',
                            'content' => $oShop->getId(),
                            'force_update' => FALSE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXMODID',
                            'content' => $this->sModKey,
                            'force_update' => FALSE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXNAME',
                            'content' => $this->sModName,
                            'force_update' => FALSE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXACTIVE',
                            'content' => '0',
                            'force_update' => FALSE,
                            'use_quote' => FALSE,
                        ),
                        array(
                            'fieldname' => 'OXBASECONFIG',
                            'content' => $this->sModBaseConfKey,
                            'force_update' => TRUE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXSERIAL',
                            'content' => "",
                            'force_update' => FALSE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXINSTALLDATE',
                            'content' => "NOW()",
                            'force_update' => TRUE,
                            'use_quote' => FALSE,
                        ),
                        array(
                            'fieldname' => 'OXVERSION',
                            'content' => $this->sModVersion,
                            'force_update' => TRUE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXSHOPVERSION',
                            'content' => oxRegistry::getConfig()->getEdition(),
                            'force_update' => TRUE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXREQUIREMENTS',
                            'content' => $this->sRequirements,
                            'force_update' => TRUE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => $this->_getLangAbbrFieldName('d3_cfg_mod', 'OXVALUE', 'de'),
                            'content' => '',
                            'force_update' => FALSE,
                            'use_quote' => TRUE,
                        ),
                        array(
                            'fieldname' => 'OXNEWREVISION',
                            'content' => $this->sModRevision,
                            'force_update' => TRUE,
                            'use_quote' => TRUE,
                        )
                    );
                    $aRet = $this->_updateTableItem('d3_cfg_mod', $aInsertFields, $aWhere);
                    $blRet = $aRet['blRet'];
                    $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
                    $this->_setUpdateBreak(true);
                }
            }
        }
        return $blRet;
    }

    /**
     * @return bool
     */
    public function checkVoucherSeriesItemExist()
    {
        $sShopEdition = oxRegistry::getConfig()->getActiveShop()->oxshops__oxedition->value;
        if ($sShopEdition == 'EE') {
            $sShopId = '1';
        } else {
            $sShopId = 'oxbaseshop';
        }

        $aWhere = array(
        'oxid'     => 'oxidbirthdayvouchers',
        'oxshopid' => $sShopId,
        );

        $blRet = $this->_checkTableItemNotExist('oxvoucherseries', $aWhere);

        if ($blRet) {
            return $blRet;
        }

        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateVoucherSeriesItemExist()
    {
        $sShopEdition = oxRegistry::getConfig()->getActiveShop()->oxshops__oxedition->value;
        if ($sShopEdition == 'EE') {
            $sShopId = '1';
        } else {
            $sShopId = 'oxbaseshop';
        }

        $blRet = FALSE;
        if ($this->checkVoucherSeriesItemExist()) {
                $aWhere = array(
                    'oxid' => 'oxidbirthdayvouchers',
                    'oxshopid' => $sShopId,
                );
                $aInsertFields = array(
                    array(
                        'fieldname' => 'OXID',
                        'content' => 'oxidbirthdayvouchers',
                        'force_update' => FALSE,
                        'use_quote' => true,
                        'use_multilang' => FALSE,
                    ),
                    array(
                        'fieldname' => 'OXSHOPID',
                        'content' => $sShopId,
                        'force_update' => FALSE,
                        'use_quote' => TRUE,
                    ),
                    array(
                        'fieldname' => 'OXSERIENR',
                        'content' => 'Geburtstagsgutscheine (D3)',
                        'force_update' => FALSE,
                        'use_quote' => TRUE,
                    ),
                    array(
                        'fieldname' => 'OXSERIEDESCRIPTION',
                        'content' => 'Geburtstagsgutscheine',
                        'force_update' => FALSE,
                        'use_quote' => TRUE,
                    ),
                    array(
                        'fieldname' => 'OXDISCOUNT',
                        'content' => '5.00',
                        'force_update' => false,
                        'use_quote' => true,
                    ),
                    array(
                        'fieldname' => 'OXDISCOUNTTYPE',
                        'content' => 'absolute',
                        'force_update' => false,
                        'use_quote' => TRUE,
                    ),
                    array(
                        'fieldname' => 'OXBEGINDATE',
                        'content' => '2009-01-01 00:00:00',
                        'force_update' => true,
                        'use_quote' => TRUE,
                    ),
                    array(
                        'fieldname' => 'OXENDDATE',
                        'content' => '2100-12-31 00:00:00',
                        'force_update' => false,
                        'use_quote' => true,
                    ),

                    array(
                        'fieldname' => 'OXMINIMUMVALUE',
                        'content' => '20.00',
                        'force_update' => false,
                        'use_quote' => TRUE,
                    )
                );

                $sShopEdition = oxRegistry::getConfig()->getActiveShop()->oxshops__oxedition->value;
                if($sShopEdition == 'EE')
                {
                    //eintrge setzten
                }

                $aRet = $this->_updateTableItem('oxvoucherseries', $aInsertFields, $aWhere);
                $blRet = $aRet['blRet'];
                $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
                $this->_setUpdateBreak(FALSE);
            }
        return $blRet;
    }

    /**
     * @return bool
     */
    public function addCmsItems()
    {
        $blRet = TRUE;

        $aExampleJobMethods = array('executeCmsTypesItemsList_01','executeCmsTypesItemsList_02','executeCmsTypesItemsList_03');
        foreach ($aExampleJobMethods as $sJobMethod)
        {
            $blRet = $this->{$sJobMethod}();
            if (!$blRet)
            {
                break;
            }
        }
        return $blRet;
    }

    /**
     * @return bool TRUE, if update is required
     */
    public function checkCmsItems()
    {
        $blRet = FALSE;
        foreach ($this->_getShopList() as $oShop)
        {
            // change this to your inividual check criterias
            $sSql = "SELECT count(`oxid`) FROM `oxcontents`
            WHERE (
                OXLOADID = 'd3birthdayvouchersubjectmail'
                OR OXLOADID = 'd3birthdayvouchermail'
                OR OXLOADID = 'd3birthdayvoucherplainmail'
            )
            AND OXSHOPID = '".$oShop->getId()."'";

            #echo "<hr>".$sSql;
            if ($this->_getDb()->getOne($sSql) != 3)
            {
                $blRet = TRUE;
            }
        }
        return $blRet;
    }

    /**
     * @return bool
     */
    public function updateCmsItems()
    {
        return $this->_confirmMessage('D3_BIRTHDAY_UPDATE_ITEMINSTALL');
    }

    public function checkCmsItems_01()
    {
        $blRet = FALSE;
        foreach ($this->_getShopList() as $oShop)
        {
            // change this to your inividual check criterias
            $sSql = "SELECT count(`oxid`) FROM `oxcontents`
            WHERE
            OXLOADID = 'd3birthdayvouchersubjectmail'
            AND OXSHOPID = '".$oShop->getId()."'";

            #echo "<hr>".$sSql;
            if ($this->_getDb()->getOne($sSql) != 1)
            {
                $blRet = TRUE;
            }
        }
        return $blRet;
    }


    /**
     * @return bool
     */
    public function executeCmsTypesItemsList_01()
    {
        $blRet = FALSE;

        foreach ($this->_getShopList() as $oShop)
        {
            /** @var $oShop oxshop */
            $aWhere = array(
                #'oxid' => "md5('d3birthdayvouchersubjectmail " . $oShop->getId() . " de')",
                'oxshopid' => $oShop->getId(),
                'OXLOADID' => 'd3birthdayvouchersubjectmail',
            );
            $aInsertFields = array(
                array(
                    'fieldname' => 'OXID',
                    'content' => "md5('d3birthdayvouchersubjectmail " . $oShop->getId() . "')",
                    'force_update' => FALSE,
                    'use_quote' => FALSE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXLOADID',
                    'content' => 'd3birthdayvouchersubjectmail',
                    'force_update' => FALSE,
                    'use_quote' => TRUE,
                ),
                array(
                    'fieldname' => 'OXSHOPID',
                    'content' => $oShop->getId(),
                    'force_update' => FALSE,
                    'use_quote' => TRUE,
                ),
                array (
                    'fieldname'     => 'OXSNIPPET',
                    'content'       => "1",
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array (
                    'fieldname'     => 'OXTYPE',
                    'content'       => "0",
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXACTIVE',
                    'content' => '1',
                    'force_update' => FALSE,
                    'use_quote' => FALSE,
                ),
                array (
                    'fieldname'     => 'OXPOSITION',
                    'content'       => "",
                    'force_update'  => FALSE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname'     => $this->_getLangAbbrFieldName('oxcontents', 'OXTITLE', 'de'),
                    'content'       => 'Geburtstags-EMail Betreff-Text',
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array (
                    'fieldname'     => $this->_getLangAbbrFieldName('oxcontents', 'OXCONTENT', 'de'),
                    'content'       => "Ihr Gutschein zum Geburtstag!",
                    'force_update'  => FALSE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),

                array(
                    'fieldname'     => 'OXCATID',
                    'content'       => '8a142c3e4143562a5.46426637',
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                ),
                array(
                    'fieldname'     => 'OXFOLDER',
                    'content'       => 'CMSFOLDER_EMAILS',
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                ),
            );
            $aRet = $this->_updateTableItem('oxcontents', $aInsertFields, $aWhere);
            #dumpvar($aRet);
            $blRet = $aRet['blRet'];
            $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
            $this->_setUpdateBreak(FALSE);
        }
        return $blRet;
    }


    /**
     * @return bool TRUE, if update is required
     */
    public function checkCmsItems_02()
    {
        $blRet = FALSE;
        foreach ($this->_getShopList() as $oShop)
        {
            // change this to your inividual check criterias
            $sSql = "SELECT count(`oxid`) FROM `oxcontents`
            WHERE
            OXLOADID = 'd3birthdayvoucherplainmail'
            AND OXSHOPID = '".$oShop->getId()."'";

            #echo "<hr>".$sSql;
            if ($this->_getDb()->getOne($sSql) != 1)
            {
                $blRet = TRUE;
            }
        }
        return $blRet;
    }
    /**
     * @return bool
     */
    public function executeCmsTypesItemsList_02()
    {
        $blRet = FALSE;

        foreach ($this->_getShopList() as $oShop)
        {
            /** @var $oShop oxshop */
            $aWhere = array(
                #'oxid' => "md5('d3birthdayvouchersubjectmail " . $oShop->getId() . " de')",
                'oxshopid' => $oShop->getId(),
                'OXLOADID' => 'd3birthdayvoucherplainmail',
            );
            $aInsertFields = array(
                array(
                    'fieldname' => 'OXID',
                    'content' => "md5('d3birthdayvoucherplainmail " . $oShop->getId() . "')",
                    'force_update' => FALSE,
                    'use_quote' => FALSE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXLOADID',
                    'content' => 'd3birthdayvoucherplainmail',
                    'force_update' => FALSE,
                    'use_quote' => TRUE,
                ),
                array(
                    'fieldname' => 'OXSHOPID',
                    'content' => $oShop->getId(),
                    'force_update' => FALSE,
                    'use_quote' => TRUE,
                ),
                array (
                    'fieldname'     => 'OXSNIPPET',
                    'content'       => "1",
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array (
                    'fieldname'     => 'OXTYPE',
                    'content'       => "0",
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXACTIVE',
                    'content' => '1',
                    'force_update' => FALSE,
                    'use_quote' => FALSE,
                ),
                array (
                    'fieldname'     => 'OXPOSITION',
                    'content'       => "",
                    'force_update'  => FALSE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname'     => $this->_getLangAbbrFieldName('oxcontents', 'OXTITLE', 'de'),
                    'content' => 'Geburtstags-EMail Plain-Text',
                    'force_update' => TRUE,
                    'use_quote' => TRUE,
                    'use_multilang' => FALSE,
                ),
                array (
                    'fieldname'     => $this->_getLangAbbrFieldName('oxcontents', 'OXCONTENT', 'de'),
                    'content'       => 'Guten Tag [{ $user->oxuser__oxsal->value|oxmultilangsal }] [{ $user->oxuser__oxfname->value }] [{ $user->oxuser__oxlname->value }],\r\n\r\nIhr [{ $shop->oxshops__oxname->value }] mchte Ihnen ganz herzlich zum Geburtstag gratulieren.\r\n\r\nAls kleines Prsent senden wir Ihnen im Folgenden einen Gutschein im Wert von [{$voucherserie->oxvoucherseries__oxdiscount->value|string_format:"%.2f"|replace:".":","}] [{if $voucherserie->oxvoucherseries__oxdiscounttype->value == "absolute"}]EUR[{else}]%[{/if}] zu.\r\n\r\n\r\nIhre persnlicher Geburtstagsgutschein-Nr. lautet: [{$voucher->oxvouchers__oxvouchernr->value}]\r\n\r\nUnd so einfach gehts:\r\nGehen Sie in unseren Onlineshop unter [{ $shop->oxshops__oxurl->value }].\r\nStbern Sie in Ruhe unter der Vielzahl an Aritkeln und legen Sie die gewnschten Produkte in den Warenkorb.\r\nKlicken Sie nun auf den Warenkorb um eine bersicht Ihrer gewhlten Artikel zu sehen.\r\nUnter der Artikelliste finden Sie das Eingabefeld fr den Gutscheincode.\r\nGeben Sie diesen dort ein, besttigen Sie die Eingabe und fhren Sie den Bestellvorgang ganz normal durch.\r\n\r\nIn Schritt 4 des Bestellvorgangs sehen Sie nun in der Zusammenfassung den abgezogenen Gutscheinwert.\r\n\r\nNoch einen schnen Tag wnscht\r\n\r\nIhr  [{ $shop->oxshops__oxname->value }] Team',
                    'force_update'  => FALSE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXCATID',
                    'content' => '8a142c3e4143562a5.46426637',
                    'force_update' => TRUE,
                    'use_quote' => TRUE,
                ),
                array(
                    'fieldname' => 'OXFOLDER',
                    'content' => 'CMSFOLDER_EMAILS',
                    'force_update' => TRUE,
                    'use_quote' => TRUE,
                ),
            );
            $aRet = $this->_updateTableItem('oxcontents', $aInsertFields, $aWhere);
            #dumpvar($aRet);
            $blRet = $aRet['blRet'];
            $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
            $this->_setUpdateBreak(FALSE);
        }
        return $blRet;
    }


    /**
     * @return bool TRUE, if update is required
     */
    public function checkCmsItems_03()
    {
        $blRet = FALSE;
        foreach ($this->_getShopList() as $oShop)
        {
            // change this to your inividual check criterias
            $sSql = "SELECT count(`oxid`) FROM `oxcontents`
            WHERE
            OXLOADID = 'd3birthdayvouchermail'
            AND OXSHOPID = '".$oShop->getId()."'";

            #echo "<hr>".$sSql;
            if ($this->_getDb()->getOne($sSql) != 1)
            {
                $blRet = TRUE;
            }
        }
        return $blRet;
    }
    /**
     * @return bool
     */
    public function executeCmsTypesItemsList_03()
    {
        $blRet = FALSE;

        foreach ($this->_getShopList() as $oShop)
        {
            /** @var $oShop oxshop */
            $aWhere = array(
                #'oxid' => "md5('d3birthdayvouchersubjectmail " . $oShop->getId() . " de')",
                'oxshopid' => $oShop->getId(),
                'OXLOADID' => 'd3birthdayvouchermail',
            );
            $aInsertFields = array(
                array(
                    'fieldname' => 'OXID',
                    'content' => "md5('d3birthdayvouchermail " . $oShop->getId() . "')",
                    'force_update' => FALSE,
                    'use_quote' => FALSE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXLOADID',
                    'content' => 'd3birthdayvouchermail',
                    'force_update' => FALSE,
                    'use_quote' => TRUE,
                ),
                array(
                    'fieldname' => 'OXSHOPID',
                    'content' => $oShop->getId(),
                    'force_update' => FALSE,
                    'use_quote' => TRUE,
                ),
                array (
                    'fieldname'     => 'OXSNIPPET',
                    'content'       => "1",
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array (
                    'fieldname'     => 'OXTYPE',
                    'content'       => "0",
                    'force_update'  => TRUE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXACTIVE',
                    'content' => '1',
                    'force_update' => FALSE,
                    'use_quote' => FALSE,
                ),
                array (
                    'fieldname'     => 'OXPOSITION',
                    'content'       => "",
                    'force_update'  => FALSE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => $this->_getLangAbbrFieldName('oxcontents', 'OXTITLE', 'de'),
                    'content' => 'Geburtstags-EMail Text',
                    'force_update' => TRUE,
                    'use_quote' => TRUE,
                    'use_multilang' => FALSE,
                ),
                array (
                    'fieldname'     => $this->_getLangAbbrFieldName('oxcontents', 'OXCONTENT', 'de'),
                    'content'       => 'Guten Tag [{$user->oxuser__oxsal->value|oxmultilangsal}] [{$user->oxuser__oxfname->value}] [{$user->oxuser__oxlname->value}],
<p>Ihr [{ $shop->oxshops__oxname->value }] mchte Ihnen ganz herzlich zum Geburtstag gratulieren.<br>
<br>
Als kleines Prsent senden wir Ihnen im Folgenden einen Gutschein im Wert von
[{$voucherserie->oxvoucherseries__oxdiscount->value|string_format:"%.2f"|replace:".":","}] [{if $voucherserie->oxvoucherseries__oxdiscounttype->value == "absolute"}]EUR[{else}]%[{/if}] zu.<br>
</p>
<p>Ihre persnlicher Geburtstagsgutschein-Nr. lautet: <strong>[{$voucher->oxvouchers__oxvouchernr->value}]</strong></p>
<p><br>
Und so einfach gehts:<br />
Gehen Sie in unseren Onlineshop unter [{ $shop->oxshops__oxurl->value }].<br>
Stbern Sie in Ruhe unter der Vielzahl an Aritkeln und legen Sie die gewnschten Produkte in den Warenkorb.<br />
Klicken Sie nun auf den Warenkorb um eine bersicht Ihrer gewhlten Artikel zu sehen.<br>
Unter der Artikelliste finden Sie das Eingabefeld fr den Gutscheincode.<br />
Geben Sie diesen dort ein, besttigen Sie die Eingabe und fhren Sie den Bestellvorgang ganz normal durch.<br />
In Schritt 4 des Bestellvorgangs sehen Sie nun in der Zusammenfassung den abgezogenen Gutscheinwert.<br />
<br />
Noch einen schnen Tag wnscht</p>
<p>Ihr  [{ $shop->oxshops__oxname->value }] Team </p>',
                    'force_update'  => FALSE,
                    'use_quote'     => TRUE,
                    'use_multilang' => FALSE,
                ),
                array(
                    'fieldname' => 'OXCATID',
                    'content' => '8a142c3e4143562a5.46426637',
                    'force_update' => TRUE,
                    'use_quote' => TRUE,
                ),
                array(
                    'fieldname' => 'OXFOLDER',
                    'content' => 'CMSFOLDER_EMAILS',
                    'force_update' => TRUE,
                    'use_quote' => TRUE,
                ),
            );
            $aRet = $this->_updateTableItem('oxcontents', $aInsertFields, $aWhere);
            #dumpvar($aRet);
            $blRet = $aRet['blRet'];
            $this->_setActionLog('SQL', $aRet['sql'], __METHOD__);
            $this->_setUpdateBreak(FALSE);
        }
        return $blRet;
    }
}